pipeline { 
    agent any

    environment { 
        IMAGE_NAME = "golang-app"
        CONTAINER_NAME = "my-golang-app"
        REMOTE_IMAGE_NAME = "registry.gitlab.com/laetitia.kougbeadjo/projet-devops"
        REGISTRY_ADDRESS = "registry.gitlab.com"
    }
    stages {
        stage('Requirements') {
            steps { 
                checkout scm
                echo 'go version'
                sh 'docker -v'
            }
        }
        stage('Update Gitlab') {
         steps {
            echo 'Notify GitLab'
            updateGitlabCommitStatus name: 'build', state: 'pending'
            updateGitlabCommitStatus name: 'build', state: 'success'
         }
       }
        stage('build') { 
                steps {
                    sh 'cd $WORKSPACE'
                    echo 'Curently building the image...'
                    sh 'docker build -t ${IMAGE_NAME}:${BUILD_ID} .'
                    sh "docker run -d --rm --name ${CONTAINER_NAME} -p 5000:5000 ${IMAGE_NAME}:${BUILD_ID}"
                }
                post {
                    success {
                        echo "Container was running" 
                    } 

                    failure {
                        sh "docker run -d --rm --name ${CONTAINER_NAME} -p 5000:5000 ${IMAGE_NAME}"
                    }
                }
        }
        stage('Run Tests') {
            parallel {
                stage('Testing using Curl...') {
                    steps {
                        echo 'Testing using CURL...'
                        sh 'curl localhost:5000'
                    }
                }
                stage('Testing using Wget...') {
                    steps {
                        echo "Test on Linux"
                        sh 'wget localhost:5000'
                    }
                }
            }
        }
        stage('Cleaning environment'){
            steps{
                sh "docker rm -f ${CONTAINER_NAME}"
            }
        }
        stage('Push to repository') {
            steps {
                echo 'Pushing to repository...'
                sh 'docker login ${REGISTRY_ADDRESS} -u laetitia.kougbeadjo -p Kaldjo12345'
                sh 'docker image tag ${IMAGE_NAME}:${BUILD_ID} ${REMOTE_IMAGE_NAME}:${BUILD_ID}'
                sh 'docker push ${REMOTE_IMAGE_NAME}:${BUILD_ID}'
            }
        }
        stage('Scan with Anchore') {
            steps {
                sh 'echo "${REMOTE_IMAGE_NAME}:${BUILD_ID} `pwd`/dockerfile" > anchore_images'
                anchore name: 'anchore_images', bailOnFail: false, engineRetries: '500', bailOnPluginFail: false
            }
        }
        stage('Deploy') {
            steps {
                echo 'Deploying....'
            }

            post {
                success {
                    echo 'Docker Image built successfully worked...'
                }
                failure {
                    echo "Docker Image build failure..."
                }
            }
        }
    }
}
